<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 10/11/2003 *
 * ===================                          Last change: 09/21/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-config_other.php                            *
 * -------------------------------------------------------------------- *
 * Short description : basic settings                                   *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Grund Einstellungen                              *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addMenuDescription('admin', __FILE__);

if (!isExtensionActive('other')) {
	// Missing extension!
	loadTemplate('admin_settings_saved', false, generateExtensionInactiveNotInstalledMessage('other'));
	return;
} // END - if

// Stop saving data if one input field is !isset
if (isFormSent()) {
	// Calculate stamps and set calculated stamps
	setPostRequestElement('online_timeout'       , createTimestampFromSelections('ip_timeout'           , postRequestArray()));
	setPostRequestElement('url_tlock'            , createTimestampFromSelections('url_tlock'            , postRequestArray()));
	setPostRequestElement('profile_lock'         , createTimestampFromSelections('profile_lock'         , postRequestArray()));
	setPostRequestElement('profile_update'       , createTimestampFromSelections('profile_update'       , postRequestArray()));
	setPostRequestElement('resend_profile_update', createTimestampFromSelections('resend_profile_update', postRequestArray()));

	// Online-Timeout shall be > 0 or your database will crow and crow and crow...
	if (!isPostRequestElementSet('online_timeout'))        { unsetPostRequestElement('ok'); }

	// Chedck other timestamps (which can be zero!)
	if (!isPostRequestElementSet('profile_lock'))          { unsetPostRequestElement('ok'); }
	if (!isPostRequestElementSet('url_tlock'))             { unsetPostRequestElement('ok'); }
	if (!isPostRequestElementSet('profile_update'))        { unsetPostRequestElement('ok'); }
	if (!isPostRequestElementSet('resend_profile_update')) { unsetPostRequestElement('ok'); }

	// Check other settings
	if (!isPostRequestElementSet('max_send'))              { unsetPostRequestElement('ok'); }
	if (!isPostRequestElementSet('code_length'))           { unsetPostRequestElement('ok'); }
	if (!isPostRequestElementSet('reject_url'))            { unsetPostRequestElement('ok'); }
}

if (isFormSent()) {
	// Update stamps directly
	adminSaveSettingsFromPostData();
} else {
	// Time selection boxes
	$content['online_timeout']   = createTimeSelections(getConfig('online_timeout'), 'ip_timeout'           , 'ms');
	$content['url_tlock']        = createTimeSelections(getConfig('url_tlock')     , 'url_tlock'            , 'WDh');
	$content['profile_lock']     = createTimeSelections(getConfig('profile_lock')  , 'profile_lock'         , 'WDh');
	$content['profile_update']   = createTimeSelections(getConfig('profile_update'), 'profile_update'       , 'YM');
	$content['profile_reupdate'] = createTimeSelections(getConfig('resend_profile_update') , 'resend_profile_update', 'MWD');

	// Prepare more Y/N selections
	foreach(array('show_points_unconfirmed','show_timings','youre_here','member_menu','guest_menu','order_multi_page','autosend_active','send_prof_update','admin_notify','display_debug_sqls') as $entry) {
		$content[$entry . '_y'] = '';
		$content[$entry . '_n'] = '';
		$content[$entry . '_' . strtolower(getConfig($entry))] = ' checked="checked"';
	} // END - foreach

	// Prepare more
	foreach (array('css_php_direct','css_php_file','css_php_inline','mailid_error_redirect_index','mailid_error_redirect_reject') as $entry) {
		$content[$entry] = '';
	} // END - foreach

	// Set selections
	foreach (array('css_php','mailid_error_redirect') as $entry) {
		$content[$entry . '_' . strtolower(getConfig($entry))] = ' checked="checked"';
	} // END - foreach

	for ($i = '0'; $i <= 5; $i++) {
		$content['comma_def_' . $i] = '';
	} // END - for

	// Set selection
	$content['comma_def_' . getConfig('max_comma')] = ' selected="selected"';

	// Load template
	loadTemplate('admin_config_other', false, $content);
}

// [EOF]
?>
