<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 10/10/2003 *
 * ===================                          Last change: 11/26/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-register.php                                *
 * -------------------------------------------------------------------- *
 * Short description : Registration form                                *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Anmeldeformular                                  *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} // END - if

// Add description as navigation point
addMenuDescription('guest', __FILE__);

if (!isExtensionActive('register')) {
	loadTemplate('admin_settings_saved', false, generateExtensionInactiveNotInstalledMessage('register'));
	return;
} elseif (!isExtensionActive('country')) {
	loadTemplate('admin_settings_saved', false, generateExtensionInactiveNotInstalledMessage('country'));
	return;
}

// Initialize variables
$isOkay     = true;
$shortPass  = false;
$cats       = '0';
$ipTimedOut = false;

// Default refid is zero
setPostRequestElement('refid', 0);
if (determineReferalId() > 0) {
	// Test if the refid is valid
	if (!fetchUserData(determineReferalId())) {
		// Not found so we set your refid!
		setPostRequestElement('refid', getConfig('def_refid'));
		setSession('refid', getConfig('def_refid'));
	} else {
		// Use the refid here
		setPostRequestElement('refid', determineReferalId());
	}
} // END - if

if (isFormSent()) {
	// First we only check the submitted data then we continue... :)
	//
	// Did he agree to our Terms Of Usage?
	if (postRequestElement('agree') != 'Y') {
		setPostRequestElement('agree', '!');
		$isOkay = false;
	} // END - if

	// Did he enter a valid email address? (we really don't care about
	// that, he has to click on a confirmation link :P )
	if ((!isPostRequestElementSet('email')) || (!isEmailValid(postRequestElement('email')))) {
		setPostRequestElement('email', '!');
		$isOkay = false;
	} // END - if

	// And what about surname and family's name?
	if (!isPostRequestElementSet('surname')) {
		setPostRequestElement('surname', '!');
		$isOkay = false;
	} // END - if
	if (!isPostRequestElementSet('family')) {
		setPostRequestElement('family', '!');
		$isOkay = false;
	} // END - if

	// Get temporary array for modification
	$postArray = postRequestArray();

	// Check for required fields
	if ($isOkay === true) $isOkay = ifRequiredRegisterFieldsAreSet($postArray);

	// Set it back in request
	setPostRequestArray($postArray);

	// Did he enter his password twice?
	if (((!isPostRequestElementSet('pass1')) || (!isPostRequestElementSet('pass2'))) || ((postRequestElement('pass1') != postRequestElement('pass2')) && (isPostRequestElementSet('pass1')) && (isPostRequestElementSet('pass2')))) {
		if ((postRequestElement('pass1') != postRequestElement('pass2')) && (isPostRequestElementSet('pass1')) && (isPostRequestElementSet('pass2'))) {
			setPostRequestElement('pass1', '!');
			setPostRequestElement('pass2', '!');
		} else {
			if (!isPostRequestElementSet('pass1')) { setPostRequestElement('pass1', '!'); } else { setPostRequestElement('pass1', ''); }
			if (!isPostRequestElementSet('pass2')) { setPostRequestElement('pass2', '!'); } else { setPostRequestElement('pass2', ''); }
		}
		$isOkay = false;
	} // END - if

	// Is the password long enouth?
	if ((strlen(postRequestElement('pass1')) < getConfig('pass_len')) && ($isOkay === true)) {
		$shortPass = true;
		$isOkay = false;
	} // END - if

	// No admin? Admins can always register!
	if (!isAdmin()) {
		// Do this check only when no admin is logged in
		foreach (postRequestElement('cat') as $id => $answer) {
			if ($answer == 'Y') $cats++;
		} // END - foreach

		if ($cats < getConfig('least_cats')) {
			// ... nope!
			$isOkay = false;
		} // END - if
	} // END - if

	if ((postRequestElement('email') != '!') && (getConfig('check_double_email') == 'Y')) {
		// Does the email address already exists in our database?
		if ((!isAdmin()) && (isEmailTaken(postRequestElement('email')))) {
			setPostRequestElement('email', '?');
			$isOkay = false;
		} // END - if
	} // END - if

	// Check for IP timeout?
	if (getConfig('ip_timeout') > 0) {
		// Check his IP number
		$result = SQL_QUERY_ESC("SELECT
	`userid`
FROM
	`{?_MYSQL_PREFIX?}_user_data`
WHERE
	`REMOTE_ADDR`='%s' AND
	(`joined` > (UNIX_TIMESTAMP() - {?ip_timeout?}) OR `last_update` > (UNIX_TIMESTAMP() - {?ip_timeout?}))
LIMIT 1",
			array(detectRemoteAddr()), __FILE__, __LINE__);
		if (SQL_NUMROWS($result) == 1) {
			// Same IP in timeout range and different email address entered... Eat this, faker! ;-)
			// But admins are allowed to fake their own exchange service.
			$ipTimedOut = true;
			$isOkay = false;
		} // END - if

		// Free memory
		SQL_FREERESULT($result);
	} // END - if
} // END - if

// Is the form sent and all went fine or admin logged in?
//* DEBUG: */ print intval(isFormSent()).'/'.intval($isOkay).'/'.intval(isAdmin()).'<br />';
if ((isFormSent()) && (($isOkay === true) || (isAdmin()))) {
	// Prepapre month and day of birth
	if (strlen(postRequestElement('day'))   == 1) setPostRequestElement('day'  , 0 . postRequestElement('day'));
	if (strlen(postRequestElement('month')) == 1) setPostRequestElement('month', 0 . postRequestElement('month'));

	// Get total ...
	// ... confirmed, ...
	$confirmedUsers   = countSumTotalData('CONFIRMED'  , 'user_data', 'userid', 'status', true);
	// ... unconfirmed ...
	$unconfirmedUsers = countSumTotalData('UNCONFIRMED', 'user_data', 'userid', 'status', true);
	// ... and locked users!
	$lockedUsers      = countSumTotalData('LOCKED'     , 'user_data', 'userid', 'status', true);

	// Generate hash which will be inserted into confirmation mail
	$hash = generateHash(sha1($confirmedUsers.getConfig('ENCRYPT_SEPERATOR').$unconfirmedUsers.getConfig('ENCRYPT_SEPERATOR').$lockedUsers.getConfig('ENCRYPT_SEPERATOR').postRequestElement('month') . '-'.postRequestElement('day') . '-'.postRequestElement('year').getConfig('ENCRYPT_SEPERATOR').getenv('SERVER_NAME').getConfig('ENCRYPT_SEPERATOR').detectRemoteAddr().getConfig('ENCRYPT_SEPERATOR').detectUserAgent() . '/' . getConfig('SITE_KEY') . '/' . getConfig('DATE_KEY') . '/'. getConfig('CACHE_BUSTER')));

	// Add design when extension sql_patches is v0.2.7 or greater
	// @TODO Rewrite these all to a single filter
	$ADD1 = '';
	$ADD2 = '';
	if (isExtensionInstalledAndNewer('theme', '0.0.8')) {
		// Okay, add design here
		$ADD1 = ', `curr_theme`';
		$ADD2 = ", '".getCurrentTheme()."'";
	} // END - if

	// Check if I shall disable sending mail to newly registered members out about active/begging rallye
	//
	// First comes first: begging rallye
	if (isExtensionInstalledAndNewer('beg', '0.1.7')) {
		// Okay, shall I disable now?
		if (getConfig('beg_new_mem_notify') != 'Y') {
			$ADD1 .= ', `beg_ral_notify`, `beg_ral_en_notify`';
			$ADD2 .= ', UNIX_TIMESTAMP(), UNIX_TIMESTAMP()';
		} // END - if
	} // END - if

	// Second: active rallye
	if (isExtensionInstalledAndNewer('bonus', '0.7.7')) {
		// Okay, shall I disable now?
		if (getConfig('bonus_new_mem_notify') != 'Y') {
			$ADD1 .= ', `bonus_ral_notify`, `bonus_ral_en_notify`';
			$ADD2 .= ', UNIX_TIMESTAMP(), UNIX_TIMESTAMP()';
		} // END - if
	} // END - if

	// Write user data to table
	if (isExtensionActive('country')) {
		// Save with new selectable country code
		$countryRow = '`country_code`';
		$countryData = bigintval(postRequestElement('country_code'));
	} else {
		// Old way with enterable two-char-code
		$countryRow = '`country`';
		$countryData = substr(postRequestElement('cntry'), 0, 2);
	}

	//////////////////////////////
	// Create user's account... //
	//////////////////////////////
	//
	SQL_QUERY_ESC("INSERT INTO `{?_MYSQL_PREFIX?}_user_data` (gender, surname, family, street_nr,%s, zip, city, email, birth_day, birth_month, birth_year, password, max_mails, receive_mails, refid, status, user_hash, REMOTE_ADDR, joined, last_update".$ADD1.")
VALUES ('%s','%s','%s','%s','%s',%s,'%s','%s',%s, %s,%s,'%s',%s, %s,'%s','UNCONFIRMED','%s','%s', UNIX_TIMESTAMP(), UNIX_TIMESTAMP()".$ADD2.")",
	array(
		$countryRow,
		substr(postRequestElement('gender'), 0, 1),
		postRequestElement('surname'),
		postRequestElement('family'),
		postRequestElement('street_nr'),
		$countryData,
		bigintval(postRequestElement('zip')),
		postRequestElement('city'),
		postRequestElement('email'),
		bigintval(postRequestElement('day')),
		bigintval(postRequestElement('month')),
		bigintval(postRequestElement('year')),
		generateHash(postRequestElement('pass1')),
		bigintval(postRequestElement('max_mails')),
		bigintval(postRequestElement('max_mails')),
		bigintval(postRequestElement('refid')),
		$hash,
		detectRemoteAddr(),
	), __FILE__, __LINE__);

	// Get his userid
	$userid = SQL_INSERTID();

	// Did this work?
	if ($userid == '0') {
		// Something bad happened!
		loadTemplate('admin_settings_saved', false, getMessage('USER_NOT_REGISTERED'));
		return;
	} // END - if

	// Is the refback extension there?
	// @TODO Rewrite this to a filter
	if (isExtensionActive('refback')) {
		// Update refback table
		updateRefbackTable($userid);
	} // END - if

	// Write his welcome-points
	$result = SQL_QUERY_ESC("SELECT `id` FROM `{?_MYSQL_PREFIX?}_user_points` WHERE `userid`=%s AND `ref_depth`=0 LIMIT 1",
		array(bigintval($userid)), __FILE__, __LINE__);
	if (SQL_NUMROWS($result) == '0') {
		// Add only when the line was not found (maybe some more secure?)
		$locked = 'points';

		// Pay him later. First he has to confirm some mails!
		if (getConfig('ref_payout') > 0) $locked = 'locked_points';

		// @TODO Rewrite this to addPointsDirectly()
		SQL_QUERY_ESC("INSERT INTO `{?_MYSQL_PREFIX?}_user_points` (`userid`, `ref_depth`, `".$locked."`) VALUES (%s,0,'{?points_register?}')",
			array(bigintval($userid)), __FILE__, __LINE__);

		// Update mediadata as well
		if ((isExtensionInstalledAndNewer('mediadata', '0.0.4')) && ($locked == 'points')) {
			// Update database
			updateMediadataEntry(array('total_points'), 'add', getConfig('points_register'));
		} // END - if
	} // END - if

	// Write catgories
	if ((is_array(postRequestElement('cat'))) && (count(postRequestElement('cat')))) {
		foreach (postRequestElement('cat') as $cat => $joined) {
			if ($joined == 'Y') {
				// Insert category entry
				SQL_QUERY_ESC("INSERT INTO `{?_MYSQL_PREFIX?}_user_cats` (userid, cat_id) VALUES (%s, %s)",
				array(bigintval($userid), bigintval($cat)), __FILE__, __LINE__);
			} // END - if
		} // END - foreach
	} // END - if

	// Rewrite gender
	$gender = translateGender(postRequestElement('gender'));

	// ... rewrite a zero referal id to the main title
	if (postRequestElement('refid') == '0') setPostRequestElement('refid', getConfig('MAIN_TITLE'));

	// Is ZIP code set?
	if (isPostRequestElementSet('zip')) {
		// Prepare data array for the email template
		// Start with the gender...
		$content = array(
			'hash'    => $hash,
			'userid'  => $userid,
			'gender'  => $gender,
			'surname' => SQL_ESCAPE(postRequestElement('surname')),
			'family'  => SQL_ESCAPE(postRequestElement('family')),
			'email'   => SQL_ESCAPE(postRequestElement('email')),
			'street'  => SQL_ESCAPE(postRequestElement('street_nr')),
			'city'    => SQL_ESCAPE(postRequestElement('city')),
			'zip'     => bigintval(postRequestElement('zip')),
			'country' => $countryData,
			'refid'   => SQL_ESCAPE(postRequestElement('refid')),
			'pass'    => SQL_ESCAPE(postRequestElement('pass1')),
		);
	} else {
		// No ZIP code entered
		$content = array(
			'hash'    => $hash,
			'userid'  => $userid,
			'gender'  => $gender,
			'surname' => SQL_ESCAPE(postRequestElement('surname')),
			'family'  => SQL_ESCAPE(postRequestElement('family')),
			'email'   => SQL_ESCAPE(postRequestElement('email')),
			'street'  => SQL_ESCAPE(postRequestElement('street_nr')),
			'city'    => SQL_ESCAPE(postRequestElement('city')),
			'zip'     => '',
			'country' => $countryData,
			'refid'   => SQL_ESCAPE(postRequestElement('refid')),
			'pass'    => SQL_ESCAPE(postRequestElement('pass1')),
		);
	}

	// Continue with birthday...
	switch (getLanguage()) {
		case 'de':
			$content['birthday'] = bigintval(postRequestElement('day')) . '.' . bigintval(postRequestElement('month')) . '.' . bigintval(postRequestElement('year'));
			break;

		default:
			$content['birthday'] = bigintval(postRequestElement('month')) . '/' . bigintval(postRequestElement('day')) . '/' . bigintval(postRequestElement('year'));
			break;
	} // END - switch

	// Display information to the user that he got mail and send it away
	$messageGuest = loadEmailTemplate('register-member', $content, $userid);

	// Send mail to user (confirmation link!)
	$email = $content['email'];
	sendEmail($content['email'], getMessage('GUEST_SUBJECT_CONFIRM_LINK'), $messageGuest);
	$content['email'] = $email;

	// Send mail to admin
	sendAdminNotification(getMessage('ADMIN_SUBJECT_NEW_ACCOUNT'), 'register-admin', $content, $userid);

	// Output success registration
	loadTemplate('admin_settings_saved', false, getMessage('REGISTRATION_DONE'));
} else {
	if (postRequestElement('agree') == '!') {
		registerOutputFailedMessage('HAVE_TO_AGREE');
	} // END - if

	if (postRequestElement('email') == '!') {
		registerOutputFailedMessage('ENTER_EMAIL');
		setPostRequestElement('email', '');
	} elseif (postRequestElement('email') == '?') {
		registerOutputFailedMessage('EMAIL_ALREADY_DB');
		setPostRequestElement('email', '');
	}

	if (postRequestElement('surname') == '!') {
		registerOutputFailedMessage('ENTER_SURNAME');
		setPostRequestElement('surname', '');
	} // END - if

	if (postRequestElement('family') == '!') {
		registerOutputFailedMessage('ENTER_FAMILY');
		setPostRequestElement('family', '');
	} // END - if

	if ((postRequestElement('pass1') == '!') && (postRequestElement('pass2') == '!')) {
		registerOutputFailedMessage('ENTER_BOTH_PASSWORDS');
	} elseif (postRequestElement('pass1') == '!') {
		registerOutputFailedMessage('ENTER_PASS1');
	} elseif (postRequestElement('pass2') == '!') {
		registerOutputFailedMessage('ENTER_PASS2');
	}

	if ($shortPass === true) {
		registerOutputFailedMessage('SHORT_PASS', ': ' . getConfig('pass_len'));
	} // END - if

	if ($ipTimedOut === true) {
		registerOutputFailedMessage('REMOTE_ADDR_TIMEOUT');
	} // END - if

	if ((!empty($cats)) && ($cats < getConfig('least_cats'))) {
		registerOutputFailedMessage('', getMessage('CATS_LEAST'));
	} // END - if

	// Generate birthday selection
	switch (getLanguage()) {
		case 'de': // German date format
			$content['birthday_selection'] = addSelectionBox('day', postRequestElement('day')).addSelectionBox('month', postRequestElement('month')).addSelectionBox('year', postRequestElement('year'));
			break;

		default: // Default is the US date format... :)
			$content['birthday_selection'] = addSelectionBox('month', postRequestElement('month')).addSelectionBox('day', postRequestElement('day')).addSelectionBox('year', postRequestElement('year'));
			break;
	}

	// Adds a table for the guests with all visible categories
	$content['category_selection'] = registerGenerateCategoryTable('guest', true);

	// Adds maximum receiveable mails list... :)
	$content['max_receive_list'] = addMaxReceiveList('guest', '', true);

	// Shall I display the refid or shall I make it editable?
	if (getConfig('display_refid') == 'Y') {
		// Load "hide" form template
		$content['refid_content'] = loadTemplate('guest_register_refid_hide', true, determineReferalId());
	} else {
		// Load template to enter it
		$content['refid_content'] = loadTemplate('guest_register_refid', true, determineReferalId());
	}

	// You may want to modify the register_header.tpl.xx file and not this script when you add your scripts etc. :-)
	$content['header_content'] = loadTemplate('register_header', true);

	// Other values
	$content['surname']   = SQL_ESCAPE(postRequestElement('surname'));
	$content['family']    = SQL_ESCAPE(postRequestElement('family'));
	$content['street_nr'] = SQL_ESCAPE(postRequestElement('street_nr'));
	$content['zip']       = '';
	if (isPostRequestElementSet('zip')) {
		$content['zip']       = bigintval(postRequestElement('zip'));
	} // END - if
	$content['city']      = SQL_ESCAPE(postRequestElement('city'));
	$content['email']     = SQL_ESCAPE(postRequestElement('email'));

	// Prepare country selection box
	$OUT  = "<select name=\"country_code\" class=\"guest_select\" size=\"1\">\n";
	$whereStatement = "WHERE `is_active`='Y'";
	if (isAdmin()) $whereStatement = '';
	$OUT .= generateOptionList('countries', 'id', 'descr', postRequestElement('country_code'), 'code', $whereStatement);
	$OUT .= "</select>";
	$content['country'] = $OUT;

	// Set must-fillout fields
	$content = runFilterChain('register_must_fillout', $content);

	// Display registration form
	loadTemplate('guest_register', false, $content);
}

// [EOF]
?>
