<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 09/08/2008 *
 * ===================                          Last change: 09/08/2008 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-surfbar_book.php                            *
 * -------------------------------------------------------------------- *
 * Short description : Members can book new URLs here                   *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Mitglieder koennen URLs buchen                   *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	die();
} elseif (!isMember()) {
	// Redirect
	redirectToIndexMemberOnlyModule();
}

// Add description as navigation point
addMenuDescription('member', __FILE__);

if ((!isExtensionActive('surfbar')) && (!isAdmin())) {
	loadTemplate('admin_settings_saved', false, generateExtensionInactiveNotInstalledMessage('surfbar'));
	return;
} // END - if

// Still allowed to book more URLs?
if (!SURFBAR_IF_USER_BOOK_MORE_URLS()) {
	// No more URLs allowed to book!
	loadTemplate('admin_settings_saved', false, getMessage('MEMBER_SURFBAR_NO_MORE_ALLOWED'));
} elseif ((isFormSent()) && (isPostRequestElementSet(('limited')))) {
	// Is limitation "no" and "limit" is > 0?
	if ((postRequestElement('limited') != 'Y') && ((isPostRequestElementSet(('limit'))) && (postRequestElement('limit') > 0)) || (!isPostRequestElementSet(('limit')))) {
		// Set it to unlimited
		setPostRequestElement('limit', 0);
	} // END - if

	// Register the new URL
	$insertId = SURFBAR_MEMBER_ADD_URL(postRequestElement('url'), postRequestElement('limit'));

	// By default something went wrong
	$message = getMessage('MEMBER_SURFBAR_URL_NOT_ADDED');

	// Was this fine?
	if ($insertId > 0) {
		// URL added and waiting for unlock
		$message = getMessage('MEMBER_SURFBAR_URL_ADDED');
	} // END - if

	// Load message template
	loadTemplate('admin_settings_saved', false, $message);
} else {
	// Prepare some content
	$content = array(
		'reward'     => translateComma(SURFBAR_DETERMINE_REWARD(true)),
		'costs'      => translateComma(SURFBAR_DETERMINE_COSTS(true)),
		'max_order'  => getConfig('surfbar_max_order'),
		'curr_order' => SURFBAR_GET_TOTAL_USER_URLS()
	);

	// Load surfbar order form
	loadTemplate(sprintf("member_surfbar_book_%s", strtolower(getConfig('surfbar_pay_model'))), false, $content);
}

//
?>
